// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0
// source: tariffs.sql

package generated

import (
	"context"

	"github.com/google/uuid"
)

const tariffCreate = `-- name: TariffCreate :exec
INSERT INTO digilab_demo_fbs.tariffs
(id, run_id, municipality, property_tax_owner_residential, property_tax_owner_non_residential,
    property_tax_usage_non_residential, sewerage_tax, waste_tax_one_person_household, 
    waste_tax_multi_person_household)
VALUES (
    $1, $2, $3, $4, $5, $6, $7, $8, $9
)
`

type TariffCreateParams struct {
	ID                             uuid.UUID
	RunID                          uuid.UUID
	Municipality                   string
	PropertyTaxOwnerResidential    float64
	PropertyTaxOwnerNonResidential float64
	PropertyTaxUsageNonResidential float64
	SewerageTax                    float64
	WasteTaxOnePersonHousehold     float64
	WasteTaxMultiPersonHousehold   float64
}

func (q *Queries) TariffCreate(ctx context.Context, arg *TariffCreateParams) error {
	_, err := q.exec(ctx, q.tariffCreateStmt, tariffCreate,
		arg.ID,
		arg.RunID,
		arg.Municipality,
		arg.PropertyTaxOwnerResidential,
		arg.PropertyTaxOwnerNonResidential,
		arg.PropertyTaxUsageNonResidential,
		arg.SewerageTax,
		arg.WasteTaxOnePersonHousehold,
		arg.WasteTaxMultiPersonHousehold,
	)
	return err
}

const tariffGet = `-- name: TariffGet :one
SELECT id, run_id, municipality, property_tax_owner_residential, property_tax_owner_non_residential,
    property_tax_usage_non_residential, sewerage_tax, waste_tax_one_person_household, 
    waste_tax_multi_person_household
FROM digilab_demo_fbs.tariffs
WHERE id=$1
`

func (q *Queries) TariffGet(ctx context.Context, id uuid.UUID) (*DigilabDemoFbsTariff, error) {
	row := q.queryRow(ctx, q.tariffGetStmt, tariffGet, id)
	var i DigilabDemoFbsTariff
	err := row.Scan(
		&i.ID,
		&i.RunID,
		&i.Municipality,
		&i.PropertyTaxOwnerResidential,
		&i.PropertyTaxOwnerNonResidential,
		&i.PropertyTaxUsageNonResidential,
		&i.SewerageTax,
		&i.WasteTaxOnePersonHousehold,
		&i.WasteTaxMultiPersonHousehold,
	)
	return &i, err
}

const tariffList = `-- name: TariffList :many
SELECT id, run_id, municipality, property_tax_owner_residential, property_tax_owner_non_residential,
    property_tax_usage_non_residential, sewerage_tax, waste_tax_one_person_household, 
    waste_tax_multi_person_household
FROM digilab_demo_fbs.tariffs
`

func (q *Queries) TariffList(ctx context.Context) ([]*DigilabDemoFbsTariff, error) {
	rows, err := q.query(ctx, q.tariffListStmt, tariffList)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTariff{}
	for rows.Next() {
		var i DigilabDemoFbsTariff
		if err := rows.Scan(
			&i.ID,
			&i.RunID,
			&i.Municipality,
			&i.PropertyTaxOwnerResidential,
			&i.PropertyTaxOwnerNonResidential,
			&i.PropertyTaxUsageNonResidential,
			&i.SewerageTax,
			&i.WasteTaxOnePersonHousehold,
			&i.WasteTaxMultiPersonHousehold,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const tariffListRun = `-- name: TariffListRun :many
SELECT id, run_id, municipality, property_tax_owner_residential, property_tax_owner_non_residential,
    property_tax_usage_non_residential, sewerage_tax, waste_tax_one_person_household, 
    waste_tax_multi_person_household
FROM digilab_demo_fbs.tariffs
WHERE run_id=$1
`

func (q *Queries) TariffListRun(ctx context.Context, runID uuid.UUID) ([]*DigilabDemoFbsTariff, error) {
	rows, err := q.query(ctx, q.tariffListRunStmt, tariffListRun, runID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsTariff{}
	for rows.Next() {
		var i DigilabDemoFbsTariff
		if err := rows.Scan(
			&i.ID,
			&i.RunID,
			&i.Municipality,
			&i.PropertyTaxOwnerResidential,
			&i.PropertyTaxOwnerNonResidential,
			&i.PropertyTaxUsageNonResidential,
			&i.SewerageTax,
			&i.WasteTaxOnePersonHousehold,
			&i.WasteTaxMultiPersonHousehold,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
